import { ActionFunctionAny } from 'redux-actions';
import { AsyncActionControlOptions, AsyncBaseActionControl, BaseAction, Selector } from './types';
export default class AsyncActionControl {
    label: string;
    rawKey: string;
    options: AsyncActionControlOptions;
    start: ActionFunctionAny<BaseAction>;
    success: ActionFunctionAny<BaseAction>;
    failure: ActionFunctionAny<BaseAction>;
    cancel: ActionFunctionAny<BaseAction>;
    clear: ActionFunctionAny<BaseAction>;
    getKey(actionId?: string | number): string;
    private getData;
    getStateValue(state: any, actionId?: string | number): string;
    getResultValue(state: any, actionId?: string | number): any;
    isRunning(actionId?: string | number): Selector;
    wasCancelled(actionId?: string | number): Selector;
    hasFailure(actionId?: string | number): Selector;
    isSuccessful(actionId?: string | number): Selector;
    getResult(actionId?: string | number): Selector;
    constructor(label: string, rawKey: string, stateActions: AsyncBaseActionControl, options: AsyncActionControlOptions);
}
