"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const reducer_1 = require("./reducer");
class AwaitControl {
    constructor() {
        this.keyReducer = 'rrAwaitControl';
        this.extractState = (s) => (key) => s[key];
    }
    static init(config) {
        if (!AwaitControl.control) {
            AwaitControl.control = new AwaitControl();
        }
        if (config === null || config === void 0 ? void 0 : config.keyReducer) {
            AwaitControl.control.keyReducer = config.keyReducer;
        }
        if (config === null || config === void 0 ? void 0 : config.extractState) {
            AwaitControl.control.extractState = config.extractState;
        }
        return AwaitControl.control;
    }
    static getControl() {
        if (!AwaitControl.control) {
            throw new Error('AwaitControl was not initialized.');
        }
        return AwaitControl.control;
    }
    mix(reducers) {
        if (reducers[this.keyReducer]) {
            throw new Error(`keyReducer: ${this.keyReducer} is already in use.`);
        }
        return Object.assign(Object.assign({}, reducers), { [this.keyReducer]: reducer_1.default });
    }
}
exports.default = AwaitControl;
